// area.c

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

struct compl {
  double real;
  double imag;
};

int main(){
  int i, j, iter, numoutside = 0;
  int xpoints, ypoints, maxiter;
  double area, ztemp;
  struct compl z, c;

  printf("Number of points, x axis? ");
  scanf("%d", &xpoints);
  printf("Number of points, y axis? ");
  scanf("%d", &ypoints);
  printf("Maximum number of iterations? ");
  scanf("%d", &maxiter);


/*   
 *  Outer loops run over npoints, initialise z=c
 *  Inner loop has the iteration z=z*z+c, and threshold test
 */

  for (i=0; i<xpoints; i++) {
    for (j=0; j<ypoints; j++) {
      c.real = -2.0+2.5*(double)(i)/(double)(xpoints)+1.0e-7;
      c.imag = 1.125*(double)(j)/(double)(ypoints)+1.0e-7;
      z=c;
      for (iter=0; iter<maxiter; iter++){
      	ztemp=(z.real*z.real)-(z.imag*z.imag)+c.real;
	      z.imag=z.real*z.imag*2+c.imag; 
	      z.real=ztemp; 
	      if ((z.real*z.real+z.imag*z.imag)>4.0e0) {
	        numoutside++; 
	        break;
	      }
      }
    }
  }


/*
 *  Calculate area
 */

      area=2.0*2.5*1.125*((double)(xpoints*ypoints-numoutside)/(double)(xpoints*ypoints));
     
      printf("Area of Mandlebrot set = %12.8f\n",area);
}
