#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#define MINREAL -1024.0
#define MAXREAL 1024.0

#include <sys/time.h>

double gettime(void) {
  struct timeval tv;
  gettimeofday(&tv, NULL);
  return tv.tv_sec + 1e-6 * tv.tv_usec;
}

void vecFillRand(long N, double *vec) {
  long i;

  for(i = 0; i < N; i++) 
    vec[i] = (rand() / (double) RAND_MAX)*(MAXREAL - MINREAL) + MINREAL;
}

double dotProduct(double *a, double *b, int n) {
  int i;
  double dp;

  dp = 0;
  for(i = 0; i < n; i++) {
    dp += a[i] * b[i];
  }

  return dp;
}

int main(int argc, char* argv[]) {
  int n;
  double *A, *B, sum, t1, t2;

  srand(time(NULL));

  if (argc == 2) {
    n = atoi(argv[1]);
  } else {
    printf("N?"); scanf("%d", &n);
  }
   
  A = (double *) malloc(n * sizeof(double));
  B = (double *) malloc(n * sizeof(double));
   
  vecFillRand(n, A);
  vecFillRand(n, B);
  
  t1 = gettime();
  dotProduct(A, B, n);
  t2 = gettime();

  fprintf(stdout, "%d\t%lf\n", n, t2 - t1);
  fflush(stdout);

  free(A);
  free(B);
   
  return 0;
}
